Index: codes/icosagcm/trunk/src/dynamics/caldyn_kernels_hevi.F90
===================================================================
--- codes/icosagcm/trunk/src/dynamics/caldyn_kernels_hevi.F90	(revision 926)
+++ codes/icosagcm/trunk/src/dynamics/caldyn_kernels_hevi.F90	(revision 953)
@@ -6,4 +6,5 @@
   USE transfert_mod
   USE caldyn_kernels_base_mod
+  USE abort_mod
   IMPLICIT NONE
   PRIVATE
@@ -20,4 +21,5 @@
 
   SUBROUTINE compute_theta(ps,theta_rhodz, rhodz,theta)
+    USE disvert_mod, ONLY : mass_dbk, mass_dak
     REAL(rstd),INTENT(IN)    :: ps(iim*jjm)
     REAL(rstd),INTENT(IN)    :: theta_rhodz(iim*jjm,llm,nqdyn)
@@ -26,7 +28,12 @@
     INTEGER :: ij,l,iq
     REAL(rstd) :: m
+
     CALL trace_start("compute_theta")
 
+    !$acc data async &
+    !$acc present(ps(:), theta_rhodz(:,:,:), rhodz(:,:), theta(:,:,:), mass_dak(:), mass_dbk(:))
+
     IF(caldyn_eta==eta_mass) THEN ! Compute mass
+       !$acc parallel loop collapse(2) async
        DO l = ll_begin,ll_end
           !DIR$ SIMD
@@ -38,6 +45,7 @@
     END IF
 
-    DO l = ll_begin,ll_end
-       DO iq=1,nqdyn
+    !$acc parallel loop collapse(3) async
+    DO iq=1,nqdyn
+       DO l = ll_begin,ll_end
           !DIR$ SIMD
           DO ij=ij_begin_ext,ij_end_ext
@@ -47,8 +55,10 @@
     END DO
 
+    !$acc end data
     CALL trace_end("compute_theta")
   END SUBROUTINE compute_theta
 
   SUBROUTINE compute_pvort_only(u,rhodz,qu,qv)
+    USE geometry, ONLY : Av, Riv2, fv
     REAL(rstd),INTENT(IN)  :: u(iim*3*jjm,llm)
     REAL(rstd),INTENT(INOUT) :: rhodz(iim*jjm,llm)
@@ -61,9 +71,15 @@
     CALL trace_start("compute_pvort_only")  
 !!! Compute shallow-water potential vorticity
+
     IF(dysl_pvort_only) THEN
+      CALL abort_acc("HEVI_scheme/dysl_pvort_only")
 #include "../kernels/pvort_only.k90"
     ELSE
 
+    !$acc data async &
+    !$acc present(rhodz(:,:), u(:,:), qu(:,:), qv(:,:), Av(:), Riv2(:,:), fv(:))
+    
     radius_m2=radius**(-2)
+    !$acc parallel loop collapse(2) async
     DO l = ll_begin,ll_end
        !DIR$ SIMD
@@ -85,5 +101,8 @@
           qv(ij+z_down,l) =( etav+fv(ij+z_down) )/hv
        ENDDO
-
+    END DO
+
+    !$acc parallel loop collapse(2) async
+    DO l = ll_begin,ll_end
        !DIR$ SIMD
        DO ij=ij_begin,ij_end
@@ -94,6 +113,9 @@
 
     ENDDO
+
+    !$acc end data
    
     END IF ! dysl
+
     CALL trace_end("compute_pvort_only")
 
@@ -409,111 +431,126 @@
 
     IF(dysl_caldyn_fast) THEN
+       CALL abort_acc("HEVI_scheme/dysl_caldyn_fast")
 #include "../kernels/caldyn_fast.k90"
     ELSE
 
-    ! Compute Bernoulli term
-    IF(boussinesq) THEN
-       DO l=ll_begin,ll_end
-          !DIR$ SIMD
-          DO ij=ij_begin,ij_end         
-             berni(ij,l) = pk(ij,l)
-             ! from now on pk contains the vertically-averaged geopotential
-             pk(ij,l) = .5*(geopot(ij,l)+geopot(ij,l+1))
+
+       ! Default case : ported to openacc
+       IF(.not. boussinesq .and. caldyn_thermo /= thermo_moist) THEN
+          !$acc data async &
+          !$acc present(rhodz(:,:), u(:,:),pk(:,:), geopot(:,:), theta(:,:,:), du(:,:))
+
+#define BERNI(ij) .5*(geopot(ij,l)+geopot(ij,l+1))
+          !$acc parallel loop collapse(2) async
+          DO l=ll_begin,ll_end
+             !DIR$ SIMD
+             DO ij=ij_begin,ij_end
+                due_right =  0.5*(theta(ij,l,1)+theta(ij+t_right,l,1))  &
+                     *(pk(ij+t_right,l)-pk(ij,l))        &
+                     +  BERNI(ij+t_right)-BERNI(ij)
+                due_lup = 0.5*(theta(ij,l,1)+theta(ij+t_lup,l,1))    &
+                     *(pk(ij+t_lup,l)-pk(ij,l))          &
+                     +  BERNI(ij+t_lup)-BERNI(ij)
+                due_ldown = 0.5*(theta(ij,l,1)+theta(ij+t_ldown,l,1)) &
+                     *(pk(ij+t_ldown,l)-pk(ij,l))      &
+                     +   BERNI(ij+t_ldown)-BERNI(ij)
+                du(ij+u_right,l) = du(ij+u_right,l) - ne_right*due_right
+                du(ij+u_lup,l)   = du(ij+u_lup,l)   - ne_lup*due_lup
+                du(ij+u_ldown,l) = du(ij+u_ldown,l) - ne_ldown*due_ldown
+                u(ij+u_right,l) = u(ij+u_right,l) + tau*du(ij+u_right,l)
+                u(ij+u_lup,l)   = u(ij+u_lup,l)   + tau*du(ij+u_lup,l)
+                u(ij+u_ldown,l) = u(ij+u_ldown,l) + tau*du(ij+u_ldown,l)
+             END DO
           END DO
-       END DO
-    ELSE ! compressible
-
-       DO l=ll_begin,ll_end
-          SELECT CASE(caldyn_thermo)
-          CASE(thermo_theta) ! vdp = theta.dpi => B = Phi
-             !DIR$ SIMD
-             DO ij=ij_begin,ij_end         
-                berni(ij,l) = .5*(geopot(ij,l)+geopot(ij,l+1))
-             END DO
-          CASE(thermo_entropy) ! vdp = dG + sdT => B = Phi + G, G=h-Ts=T*(cpp-s) 
-             !DIR$ SIMD
-             DO ij=ij_begin,ij_end         
-                berni(ij,l) = .5*(geopot(ij,l)+geopot(ij,l+1)) &
-                     + pk(ij,l)*(cpp-theta(ij,l,1)) ! pk=temperature, theta=entropy
-             END DO
-          CASE(thermo_moist) 
-             !DIR$ SIMD
-             DO ij=ij_begin,ij_end         
-                ! du/dt = grad(Bd)+rv.grad(Bv)+s.grad(T)
-                ! Bd = Phi + gibbs_d
-                ! Bv = Phi + gibbs_v
-                ! pk=temperature, theta=entropy
-                qv = theta(ij,l,2)
-                temp = pk(ij,l)
-                chi = log(temp/Treff)
-                nu = (chi*(cpp+qv*cppv)-theta(ij,l,1))/(Rd+qv*Rv) ! log(p/preff)
-                berni(ij,l) = .5*(geopot(ij,l)+geopot(ij,l+1)) &
-                     + temp*(cpp*(1.-chi)+Rd*nu)
-                berniv(ij,l) = .5*(geopot(ij,l)+geopot(ij,l+1)) &
-                     + temp*(cppv*(1.-chi)+Rv*nu)
-            END DO
-          END SELECT
-       END DO
-
-    END IF ! Boussinesq/compressible
+
+#undef BERNI
+
+          !$acc end data
+       ELSE ! Not default case : not ported to openacc
+          CALL abort_acc("HEVI_scheme/compute_caldyn_fast")
+          !!$acc parallel loop gang private(berni(:,:), berniv(:,:)) async
+          DO l=ll_begin,ll_end
+             ! Compute Bernoulliterm
+             IF(boussinesq) THEN
+                !!$acc loop vector
+                !DIR$ SIMD
+                DO ij=ij_begin,ij_end
+                   berni(ij,l) = pk(ij,l)
+                   ! from now on pk contains the vertically-averaged geopotential
+                   pk(ij,l) = .5*(geopot(ij,l)+geopot(ij,l+1))
+                END DO
+             ELSE ! compressible
+                SELECT CASE(caldyn_thermo)
+                CASE(thermo_theta) ! vdp = theta.dpi => B = Phi
+                   CALL dynamico_abort("Case already dealt with")
+                CASE(thermo_entropy) ! vdp = dG + sdT => B = Phi + G, G=h-Ts=T*(cpp-s)
+                   !$acc loop vector
+                   !DIR$ SIMD
+                   DO ij=ij_begin,ij_end
+                      berni(ij,l) = .5*(geopot(ij,l)+geopot(ij,l+1)) &
+                           + pk(ij,l)*(cpp-theta(ij,l,1)) ! pk=temperature, theta=entropy
+                   END DO
+                CASE(thermo_moist)
+!!$acc loop vector
+                   !DIR$ SIMD
+                   DO ij=ij_begin,ij_end
+                      ! du/dt = grad(Bd)+rv.grad(Bv)+s.grad(T)
+                      ! Bd = Phi + gibbs_d
+                      ! Bv = Phi + gibbs_v
+                      ! pk=temperature, theta=entropy
+                      qv = theta(ij,l,2)
+                      temp = pk(ij,l)
+                      chi = log(temp/Treff)
+                      nu = (chi*(cpp+qv*cppv)-theta(ij,l,1))/(Rd+qv*Rv) ! log(p/preff)
+                      berni(ij,l) = .5*(geopot(ij,l)+geopot(ij,l+1)) &
+                           + temp*(cpp*(1.-chi)+Rd*nu)
+                      berniv(ij,l) = .5*(geopot(ij,l)+geopot(ij,l+1)) &
+                           + temp*(cppv*(1.-chi)+Rv*nu)
+                   END DO
+                END SELECT
+             END IF ! Boussinesq/compressible
 
 !!! u:=u+tau*du, du = -grad(B)-theta.grad(pi)
-    DO l=ll_begin,ll_end
-       IF(caldyn_thermo == thermo_moist) THEN
-          !DIR$ SIMD
-          DO ij=ij_begin,ij_end         
-             due_right =  berni(ij+t_right,l)-berni(ij,l)       &
-                  + 0.5*(theta(ij,l,1)+theta(ij+t_right,l,1))   &
-                       *(pk(ij+t_right,l)-pk(ij,l))             &
-                  + 0.5*(theta(ij,l,2)+theta(ij+t_right,l,2))   &
-                       *(berniv(ij+t_right,l)-berniv(ij,l))
-             
-             due_lup = berni(ij+t_lup,l)-berni(ij,l)            &
-                  + 0.5*(theta(ij,l,1)+theta(ij+t_lup,l,1))     &
-                       *(pk(ij+t_lup,l)-pk(ij,l))               &
-                  + 0.5*(theta(ij,l,2)+theta(ij+t_lup,l,2))     &
-                       *(berniv(ij+t_lup,l)-berniv(ij,l))
-             
-             due_ldown = berni(ij+t_ldown,l)-berni(ij,l)        &
-                  + 0.5*(theta(ij,l,1)+theta(ij+t_ldown,l,1))   &
-                       *(pk(ij+t_ldown,l)-pk(ij,l))             &
-                  + 0.5*(theta(ij,l,2)+theta(ij+t_ldown,l,2))   &
-                       *(berniv(ij+t_ldown,l)-berniv(ij,l))
-             
-             du(ij+u_right,l) = du(ij+u_right,l) - ne_right*due_right
-             du(ij+u_lup,l)   = du(ij+u_lup,l)   - ne_lup*due_lup
-             du(ij+u_ldown,l) = du(ij+u_ldown,l) - ne_ldown*due_ldown
-             u(ij+u_right,l) = u(ij+u_right,l) + tau*du(ij+u_right,l)
-             u(ij+u_lup,l)   = u(ij+u_lup,l)   + tau*du(ij+u_lup,l)
-             u(ij+u_ldown,l) = u(ij+u_ldown,l) + tau*du(ij+u_ldown,l)
-          END DO
-       ELSE
-          !DIR$ SIMD
-          DO ij=ij_begin,ij_end         
-             due_right =  0.5*(theta(ij,l,1)+theta(ij+t_right,l,1))  &
-                  *(pk(ij+t_right,l)-pk(ij,l))        &
-                  +  berni(ij+t_right,l)-berni(ij,l)
-             due_lup = 0.5*(theta(ij,l,1)+theta(ij+t_lup,l,1))    &
-                  *(pk(ij+t_lup,l)-pk(ij,l))          &
-                  +  berni(ij+t_lup,l)-berni(ij,l)
-             due_ldown = 0.5*(theta(ij,l,1)+theta(ij+t_ldown,l,1)) &
-                  *(pk(ij+t_ldown,l)-pk(ij,l))      &
-                  +   berni(ij+t_ldown,l)-berni(ij,l)
-             du(ij+u_right,l) = du(ij+u_right,l) - ne_right*due_right
-             du(ij+u_lup,l)   = du(ij+u_lup,l)   - ne_lup*due_lup
-             du(ij+u_ldown,l) = du(ij+u_ldown,l) - ne_ldown*due_ldown
-             u(ij+u_right,l) = u(ij+u_right,l) + tau*du(ij+u_right,l)
-             u(ij+u_lup,l)   = u(ij+u_lup,l)   + tau*du(ij+u_lup,l)
-             u(ij+u_ldown,l) = u(ij+u_ldown,l) + tau*du(ij+u_ldown,l)
+             IF(caldyn_thermo == thermo_moist) THEN
+!!$acc loop vector
+                !DIR$ SIMD
+                DO ij=ij_begin,ij_end
+                   due_right =  berni(ij+t_right,l)-berni(ij,l)       &
+                        + 0.5*(theta(ij,l,1)+theta(ij+t_right,l,1))   &
+                        *(pk(ij+t_right,l)-pk(ij,l))             &
+                        + 0.5*(theta(ij,l,2)+theta(ij+t_right,l,2))   &
+                        *(berniv(ij+t_right,l)-berniv(ij,l))
+
+                   due_lup = berni(ij+t_lup,l)-berni(ij,l)            &
+                        + 0.5*(theta(ij,l,1)+theta(ij+t_lup,l,1))     &
+                        *(pk(ij+t_lup,l)-pk(ij,l))               &
+                        + 0.5*(theta(ij,l,2)+theta(ij+t_lup,l,2))     &
+                        *(berniv(ij+t_lup,l)-berniv(ij,l))
+
+                   due_ldown = berni(ij+t_ldown,l)-berni(ij,l)        &
+                        + 0.5*(theta(ij,l,1)+theta(ij+t_ldown,l,1))   &
+                        *(pk(ij+t_ldown,l)-pk(ij,l))             &
+                        + 0.5*(theta(ij,l,2)+theta(ij+t_ldown,l,2))   &
+                        *(berniv(ij+t_ldown,l)-berniv(ij,l))
+
+                   du(ij+u_right,l) = du(ij+u_right,l) - ne_right*due_right
+                   du(ij+u_lup,l)   = du(ij+u_lup,l)   - ne_lup*due_lup
+                   du(ij+u_ldown,l) = du(ij+u_ldown,l) - ne_ldown*due_ldown
+                   u(ij+u_right,l) = u(ij+u_right,l) + tau*du(ij+u_right,l)
+                   u(ij+u_lup,l)   = u(ij+u_lup,l)   + tau*du(ij+u_lup,l)
+                   u(ij+u_ldown,l) = u(ij+u_ldown,l) + tau*du(ij+u_ldown,l)
+                END DO
+             ELSE
+                CALL dynamico_abort("Case already dealt with")
+             END IF
           END DO
        END IF
-    END DO
-
-    END IF ! dysl
+    END IF
     CALL trace_end("compute_caldyn_fast")
 
   END SUBROUTINE compute_caldyn_fast
-
+    
   SUBROUTINE compute_caldyn_Coriolis(hflux,theta,qu, convm,dtheta_rhodz,du)
+    USE geometry, ONLY : Ai, wee
     REAL(rstd),INTENT(IN)  :: hflux(3*iim*jjm,llm)  ! hflux in kg/s
     REAL(rstd),INTENT(IN)  :: theta(iim*jjm,llm,nqdyn) ! active scalars
@@ -534,10 +571,15 @@
 
     ELSE
-#define FTHETA(ij) Ftheta(ij,1)
-
-    DO l=ll_begin, ll_end
-       ! compute theta flux
-       DO iq=1,nqdyn
-       !DIR$ SIMD
+#define FTHETA(ij) Ftheta(ij,l)
+
+    !$acc data async &
+    !$acc create(Ftheta(3*iim*jjm,llm)) &
+    !$acc present(qu(:,:), hflux(:,:), convm(:,:), du(:,:), dtheta_rhodz(:,:,:), theta(:,:,:), Ai(:), wee(:,:,:))
+
+    ! compute theta flux
+    DO iq=1,nqdyn
+       !$acc parallel loop collapse(2) present(Ftheta, theta) async
+       DO l=ll_begin, ll_end
+          !DIR$ SIMD
           DO ij=ij_begin_ext,ij_end_ext      
              FTHETA(ij+u_right) = 0.5*(theta(ij,l,iq)+theta(ij+t_right,l,iq)) &
@@ -548,6 +590,10 @@
                   * hflux(ij+u_ldown,l)
           END DO
+       END DO
+
+       !$acc parallel loop collapse(2) present(Ftheta) async
+       DO l=ll_begin, ll_end
           ! horizontal divergence of fluxes
-       !DIR$ SIMD
+          !DIR$ SIMD
           DO ij=ij_begin,ij_end         
              ! dtheta_rhodz =  -div(flux.theta)
@@ -561,5 +607,8 @@
           END DO
        END DO
-
+    END DO
+
+    !$acc parallel loop collapse(2) present(Ai) async
+    DO l=ll_begin, ll_end
        !DIR$ SIMD
        DO ij=ij_begin,ij_end         
@@ -578,5 +627,5 @@
 
     CASE(energy) ! energy-conserving TRiSK
-
+       !$acc parallel loop collapse(2) present(qu, wee, du) async
        DO l=ll_begin,ll_end
           !DIR$ SIMD
@@ -622,5 +671,6 @@
 
     CASE(enstrophy) ! enstrophy-conserving TRiSK
-
+       
+       !$acc parallel loop collapse(2) present(wee, du) async
        DO l=ll_begin,ll_end
           !DIR$ SIMD
@@ -665,7 +715,11 @@
           END DO
        END DO
+       !$acc end parallel loop
     CASE DEFAULT
        STOP
     END SELECT
+
+    !$acc end data
+
 #undef FTHETA
 
@@ -676,5 +730,6 @@
   END SUBROUTINE compute_caldyn_Coriolis
 
-  SUBROUTINE compute_caldyn_slow_hydro(u,rhodz,hflux,du, zero)
+  SUBROUTINE compute_caldyn_slow_hydro(u,rhodz,hflux,du,zero)
+    USE geometry, ONLY : Ai, le_de
     LOGICAL, INTENT(IN) :: zero
     REAL(rstd),INTENT(IN)  :: u(3*iim*jjm,llm)    ! prognostic "velocity"
@@ -684,5 +739,4 @@
     
     REAL(rstd) :: berni(iim*jjm,llm)  ! Bernoulli function
-    REAL(rstd) :: berni1(iim*jjm)  ! Bernoulli function
     REAL(rstd) :: uu_right, uu_lup, uu_ldown, ke, uu
     INTEGER :: ij,l
@@ -698,9 +752,17 @@
      ELSE
 
-#define BERNI(ij) berni1(ij)
+#define BERNI(ij) berni(ij,l)
 
     DO l = ll_begin, ll_end
-       !  Compute mass fluxes
        IF (caldyn_conserv==energy) CALL test_message(req_qu) 
+    END DO
+    
+    !$acc data async &
+    !$acc create(berni(:,ll_begin:ll_end)) &
+    !$acc present(rhodz(:,ll_begin:ll_end), u(:,ll_begin:ll_end), hflux(:,:), du(:,ll_begin:ll_end), Ai(:), le_de(:))
+
+    !  Compute mass fluxes
+    !$acc parallel loop collapse(2) async
+    DO l = ll_begin, ll_end
        !DIR$ SIMD
        DO ij=ij_begin_ext,ij_end_ext
@@ -715,5 +777,9 @@
           hflux(ij+u_ldown,l)=uu_ldown
        ENDDO
-       ! Compute Bernoulli=kinetic energy
+    END DO
+
+    ! Compute Bernoulli=kinetic energy
+    !$acc parallel loop collapse(2) async
+    DO l = ll_begin, ll_end
        !DIR$ SIMD
        DO ij=ij_begin,ij_end         
@@ -726,6 +792,10 @@
                le_de(ij+u_rdown)*u(ij+u_rdown,l)**2 )  
        ENDDO
-       ! Compute du=-grad(Bernoulli)
-       IF(zero) THEN
+    END DO
+
+    ! Compute du=-grad(Bernoulli)
+    IF(zero) THEN
+       !$acc parallel loop collapse(2) async
+       DO l = ll_begin, ll_end
           !DIR$ SIMD
           DO ij=ij_begin,ij_end
@@ -734,5 +804,8 @@
              du(ij+u_ldown,l) = ne_ldown*(BERNI(ij)-BERNI(ij+t_ldown))
           END DO
-       ELSE
+       END DO
+    ELSE
+       !$acc parallel loop collapse(2) async
+       DO l = ll_begin, ll_end
           !DIR$ SIMD
           DO ij=ij_begin,ij_end
@@ -744,10 +817,13 @@
                   ne_ldown*(BERNI(ij)-BERNI(ij+t_ldown))
           END DO
-       END IF
-    END DO
+       END DO
+    END IF
+
+    !$acc end data
 
 #undef BERNI
 
     END IF ! dysl
+
     CALL trace_end("compute_caldyn_slow_hydro")    
   END SUBROUTINE compute_caldyn_slow_hydro
Index: codes/icosagcm/trunk/src/kernels/advect_horiz.k90
===================================================================
--- codes/icosagcm/trunk/src/kernels/advect_horiz.k90	(revision 926)
+++ codes/icosagcm/trunk/src/kernels/advect_horiz.k90	(revision 953)
@@ -1,52 +1,69 @@
    !--------------------------------------------------------------------------
    !---------------------------- advect_horiz ----------------------------------
+
+   !$acc data create(qflux(:,:)) present(qi(:,:), cc(:,:,:), gradq3d(:,:,:), mass(:,:), hfluxt(:,:), Ai(:), xyz_i(:,:)) async
+
    ! evaluate tracer field at point cc using piecewise linear reconstruction
    ! q(cc)= q0 + gradq.(cc-xyz_i) with xi centroid of hexagon
    ! sign*hfluxt>0 iff outgoing
+   !$acc parallel loop collapse(2) async
    DO l = ll_begin, ll_end
       !DIR$ SIMD
       DO ij=ij_begin_ext, ij_end_ext
          IF(ne_right*hfluxt(ij+u_right,l)>0.) THEN
-            qe = qi(ij,l)
-            qe = qe + (cc(ij+u_right,l,1)-xyz_i(ij,1))*gradq3d(ij,l,1)
-            qe = qe + (cc(ij+u_right,l,2)-xyz_i(ij,2))*gradq3d(ij,l,2)
-            qe = qe + (cc(ij+u_right,l,3)-xyz_i(ij,3))*gradq3d(ij,l,3)
+            ij_tmp = ij
          ELSE
-            qe = qi(ij+t_right,l)
-            qe = qe + (cc(ij+u_right,l,1)-xyz_i(ij+t_right,1))*gradq3d(ij+t_right,l,1)
-            qe = qe + (cc(ij+u_right,l,2)-xyz_i(ij+t_right,2))*gradq3d(ij+t_right,l,2)
-            qe = qe + (cc(ij+u_right,l,3)-xyz_i(ij+t_right,3))*gradq3d(ij+t_right,l,3)
+            ij_tmp = ij+t_right
          END IF
+
+         qe = qi(ij_tmp,l)
+         qe = qe + (cc(ij+u_right,l,1)-xyz_i(ij_tmp,1))*gradq3d(ij_tmp,l,1)
+         qe = qe + (cc(ij+u_right,l,2)-xyz_i(ij_tmp,2))*gradq3d(ij_tmp,l,2)
+         qe = qe + (cc(ij+u_right,l,3)-xyz_i(ij_tmp,3))*gradq3d(ij_tmp,l,3)
+
          qflux(ij+u_right,l) = hfluxt(ij+u_right,l)*qe
-         IF(diagflux_on) qfluxt(ij+u_right,l) = qfluxt(ij+u_right,l)+qflux(ij+u_right,l)
+
          IF(ne_lup*hfluxt(ij+u_lup,l)>0.) THEN
-            qe = qi(ij,l)
-            qe = qe + (cc(ij+u_lup,l,1)-xyz_i(ij,1))*gradq3d(ij,l,1)
-            qe = qe + (cc(ij+u_lup,l,2)-xyz_i(ij,2))*gradq3d(ij,l,2)
-            qe = qe + (cc(ij+u_lup,l,3)-xyz_i(ij,3))*gradq3d(ij,l,3)
+            ij_tmp = ij
          ELSE
-            qe = qi(ij+t_lup,l)
-            qe = qe + (cc(ij+u_lup,l,1)-xyz_i(ij+t_lup,1))*gradq3d(ij+t_lup,l,1)
-            qe = qe + (cc(ij+u_lup,l,2)-xyz_i(ij+t_lup,2))*gradq3d(ij+t_lup,l,2)
-            qe = qe + (cc(ij+u_lup,l,3)-xyz_i(ij+t_lup,3))*gradq3d(ij+t_lup,l,3)
+            ij_tmp = ij+t_lup
          END IF
+
+         qe = qi(ij_tmp,l)
+         qe = qe + (cc(ij+u_lup,l,1)-xyz_i(ij_tmp,1))*gradq3d(ij_tmp,l,1)
+         qe = qe + (cc(ij+u_lup,l,2)-xyz_i(ij_tmp,2))*gradq3d(ij_tmp,l,2)
+         qe = qe + (cc(ij+u_lup,l,3)-xyz_i(ij_tmp,3))*gradq3d(ij_tmp,l,3)
+
          qflux(ij+u_lup,l) = hfluxt(ij+u_lup,l)*qe
-         IF(diagflux_on) qfluxt(ij+u_lup,l) = qfluxt(ij+u_lup,l)+qflux(ij+u_lup,l)
+
          IF(ne_ldown*hfluxt(ij+u_ldown,l)>0.) THEN
-            qe = qi(ij,l)
-            qe = qe + (cc(ij+u_ldown,l,1)-xyz_i(ij,1))*gradq3d(ij,l,1)
-            qe = qe + (cc(ij+u_ldown,l,2)-xyz_i(ij,2))*gradq3d(ij,l,2)
-            qe = qe + (cc(ij+u_ldown,l,3)-xyz_i(ij,3))*gradq3d(ij,l,3)
+            ij_tmp = ij
          ELSE
-            qe = qi(ij+t_ldown,l)
-            qe = qe + (cc(ij+u_ldown,l,1)-xyz_i(ij+t_ldown,1))*gradq3d(ij+t_ldown,l,1)
-            qe = qe + (cc(ij+u_ldown,l,2)-xyz_i(ij+t_ldown,2))*gradq3d(ij+t_ldown,l,2)
-            qe = qe + (cc(ij+u_ldown,l,3)-xyz_i(ij+t_ldown,3))*gradq3d(ij+t_ldown,l,3)
+            ij_tmp = ij+t_ldown
          END IF
+
+         qe = qi(ij_tmp,l)
+         qe = qe + (cc(ij+u_ldown,l,1)-xyz_i(ij_tmp,1))*gradq3d(ij_tmp,l,1)
+         qe = qe + (cc(ij+u_ldown,l,2)-xyz_i(ij_tmp,2))*gradq3d(ij_tmp,l,2)
+         qe = qe + (cc(ij+u_ldown,l,3)-xyz_i(ij_tmp,3))*gradq3d(ij_tmp,l,3)
+
          qflux(ij+u_ldown,l) = hfluxt(ij+u_ldown,l)*qe
-         IF(diagflux_on) qfluxt(ij+u_ldown,l) = qfluxt(ij+u_ldown,l)+qflux(ij+u_ldown,l)
       END DO
    END DO
+
+   IF(diagflux_on) THEN
+     !$acc parallel loop collapse(2) copy(qfluxt(:,:)) async
+     DO l = ll_begin, ll_end
+        !DIR$ SIMD
+        DO ij=ij_begin_ext, ij_end_ext
+           qfluxt(ij+u_right,l) = qfluxt(ij+u_right,l)+qflux(ij+u_right,l)
+           qfluxt(ij+u_lup,l) = qfluxt(ij+u_lup,l)+qflux(ij+u_lup,l)
+           qfluxt(ij+u_ldown,l) = qfluxt(ij+u_ldown,l)+qflux(ij+u_ldown,l)
+        END DO
+     END DO
+   END IF
+
    ! update q and, if update_mass, update mass
+   !$acc parallel loop collapse(2) async
    DO l = ll_begin, ll_end
       !DIR$ SIMD
@@ -71,4 +88,7 @@
       END DO
    END DO
+   
+   !$acc end data
+
    !---------------------------- advect_horiz ----------------------------------
    !--------------------------------------------------------------------------
Index: codes/icosagcm/trunk/src/output/xios_mod.F90
===================================================================
--- codes/icosagcm/trunk/src/output/xios_mod.F90	(revision 926)
+++ codes/icosagcm/trunk/src/output/xios_mod.F90	(revision 953)
@@ -1120,4 +1120,5 @@
    CHARACTER(LEN=*),INTENT(IN) :: name
    REAL(rstd), INTENT(OUT) :: field
+   field=0
  END SUBROUTINE
  
Index: codes/icosagcm/trunk/src/parallel/mpipara.F90
===================================================================
--- codes/icosagcm/trunk/src/parallel/mpipara.F90	(revision 926)
+++ codes/icosagcm/trunk/src/parallel/mpipara.F90	(revision 953)
@@ -14,4 +14,6 @@
   INTEGER,SAVE :: id_mpi ! id for profiling
 
+  INTEGER, SAVE :: device_id
+
   INTERFACE allocate_mpi_buffer
     MODULE PROCEDURE allocate_mpi_buffer_r2, allocate_mpi_buffer_r3,allocate_mpi_buffer_r4
@@ -46,4 +48,5 @@
   USE xios
 #endif
+  USE abort_mod
   IMPLICIT NONE
     CHARACTER(LEN=256) :: required_mode_str
@@ -75,4 +78,7 @@
       END SELECT
       
+      IF (required_mode==MPI_THREAD_SERIALIZED .OR. required_mode==MPI_THREAD_MULTIPLE) THEN
+        CALL abort_acc("mpi_threading_mode /= 'single' .AND. mpi_threading_mode /= 'funneled'")
+      ENDIF
 
       IF (required_mode==MPI_THREAD_SINGLE)     PRINT*,'MPI_INIT_THREAD : MPI_SINGLE_THREAD required'
@@ -120,4 +126,12 @@
     ENDIF
     
+
+#ifdef _OPENACC
+    device_id = setDevice(mpi_size, mpi_rank)
+    PRINT *, 'GPU device ', device_id
+#else
+     device_id = -1
+#endif
+
   END SUBROUTINE  init_mpipara
 
@@ -233,3 +247,64 @@
   END SUBROUTINE free_mpi_buffer_r4
    
+#ifdef _OPENACC
+  FUNCTION setDevice(nprocs, myrank)
+    use iso_c_binding
+    use openacc
+    USE mpi_mod
+    implicit none
+    
+    interface 
+       function gethostid() bind(C)
+       use iso_c_binding
+       integer(C_INT) :: gethostid
+     end function gethostid
+  end interface
+  
+  integer, intent(in) :: nprocs, myrank
+  integer :: hostids(nprocs), localprocs(nprocs)
+  integer :: hostid, ierr, numdev, mydev, i, numlocal
+  integer :: setDevice
+
+  ! get the hostids so we can determine what other processes are on this node
+  hostid = gethostid()
+  call mpi_allgather(hostid,1,MPI_INTEGER,hostids,1,MPI_INTEGER, MPI_COMM_WORLD, ierr)
+
+  ! determine which processors are on this node
+  numlocal = 0
+  localprocs(:) = 0
+  do i = 1, nprocs
+     if (hostid == hostids(i)) then
+        localprocs(i) = numlocal
+        numlocal = numlocal + 1
+     end if
+  end do
+
+  ! get the number of device on this node
+  numdev = acc_get_num_devices(ACC_DEVICE_NVIDIA)
+
+  if (numdev < 1) then
+     print *, "Error: there are no devices available on this host. ABORTING", myrank
+     stop
+  end if
+
+  ! print a warning if the number of devices is less than the number of processes on this node. Having multiple processes share a devices is not recommended
+  if (numdev < numlocal) then
+     if (localprocs(myrank+1) == 1) then
+        ! print warning message only once per node
+        print *, "WARNING: the number of process is greater than the number of GPUs.", myrank
+     end if
+     mydev = mod(localprocs(myrank+1), numdev)
+  else
+     mydev = localprocs(myrank+1)
+  end if
+
+  call acc_set_device_num(mydev,ACC_DEVICE_NVIDIA)
+  call acc_init(ACC_DEVICE_NVIDIA)
+  setDevice = acc_get_device_num(ACC_DEVICE_NVIDIA)
+END FUNCTION setDevice
+
+#endif
+
+     
+     
 END MODULE mpipara
